Agda-2.5.2: A dependently typed functional programming language and proof assistant

Safe Haskell | None
Language | Haskell2010

Agda.TypeChecking.Patterns.Abstract

Description

Tools to manipulate patterns in abstract syntax in the TCM (type checking monad).

Synopsis

- expandLitPattern :: NamedArg Pattern -> TCM (NamedArg Pattern)
- class ExpandPatternSynonyms a where

# Documentation

expandLitPattern :: NamedArg Pattern -> TCM (NamedArg Pattern) #

Expand literal integer pattern into suc/zero constructor patterns.

class ExpandPatternSynonyms a where #

Expand away (deeply) all pattern synonyms in a pattern.

Minimal complete definition

expandPatternSynonyms

Methods

expandPatternSynonyms :: a -> TCM a #

Instances

ExpandPatternSynonyms Pattern # |
Methods expandPatternSynonyms :: Pattern -> TCM Pattern #
ExpandPatternSynonyms a => ExpandPatternSynonyms [a] # |
Methods expandPatternSynonyms :: [a] -> TCM [a] #
ExpandPatternSynonyms a => ExpandPatternSynonyms (Maybe a) # |
Methods expandPatternSynonyms :: Maybe a -> TCM (Maybe a) #
ExpandPatternSynonyms a => ExpandPatternSynonyms (Arg a) # |
Methods expandPatternSynonyms :: Arg a -> TCM (Arg a) #
ExpandPatternSynonyms a => ExpandPatternSynonyms (FieldAssignment' a) # |
Methods expandPatternSynonyms :: FieldAssignment' a -> TCM (FieldAssignment' a) #
ExpandPatternSynonyms a => ExpandPatternSynonyms (Named n a) # |
Methods expandPatternSynonyms :: Named n a -> TCM (Named n a) #